using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Data;

namespace FLY.ControlLibrary.Converter
{
    public class RatioConverter : IMultiValueConverter
    {
        #region IMultiValueConverter 成员
        double getValue(object value)
        {
            if ((value is int) && (!Misc.MyBase.ISVALIDATA((int)value)))
                return 0;

            try
            {
                return System.Convert.ToDouble(value);
            }
            catch
            {
                return 0;
            }
        }
        public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (values.Length != 3) //必须要检查，不然 界面生成器 会错误，提示转换异常
            {
                return 100;
            }

            double ratio;
            double value = getValue(values[0]);
            double max = getValue(values[1]);
            double ActualWidth = getValue(values[2]);

            if (max <= 0)
                ratio = 0;
            else
                ratio = (double)value / max;

            if (ratio < 0)
                ratio = 0;
            else if (ratio > 1)
                ratio = 1;
            return ActualWidth * ratio;
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {
            return null;
        }

        #endregion
    }

    public class RatioConverter_TimeSpan : IMultiValueConverter
    {
        #region IMultiValueConverter 成员

        public object Convert(object[] values, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (values.Length == 3 && (values[0] is TimeSpan) && (values[1] is TimeSpan) && (values[2] is double))//必须要检查，不然 界面生成器 会错误，提示转换异常
            {
                double ratio;
                TimeSpan v = (TimeSpan)values[0];
                TimeSpan max = (TimeSpan)values[1];
                double ActualWidth = (double)values[2];

                if (max.TotalSeconds <= 0)
                    ratio = 0;
                else
                    ratio = v.TotalSeconds / max.TotalSeconds;

                if (ratio < 0)
                    ratio = 0;
                else if (ratio > 1)
                    ratio = 1;

                return ActualWidth * ratio;
            }
            else
            {
                return 100;
            }
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, System.Globalization.CultureInfo culture)
        {
            return null;
        }

        #endregion
    }
}
